/* asm_byte.h - 6502 assembler (horrible unfinished hackofathing)
 *
 * Copyright (C) 2017 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef HAVE_BYTE_H
#define HAVE_BYTE_H


#define BYTE_SIZE   8
#define BYTE_MAX    256    /* 2 ^ BYTE_SIZE       */
#define WORD_MAX    65536  /* 2 ^ (BYTE_SIZE * 2) */


#define WORD_INC(w)             word_set (w, word_to_integer (w) + 1)
#define WORD_DEC(w)             word_set (w, word_to_integer (w) - 1)
#define WORD_ADD_BYTE(w, b)     word_set (w, word_to_integer (w) + b)
#define WORD_SUB_BYTE(w, b)     word_set (w, word_to_integer (w) - b)
#define WORD_ADD_WORD(w1, w2)	word_set (w1, word_to_integer (w1) + word_to_integer (w2))
#define WORD_EQ(w1, w2)         ((w1)->lsb == (w2)->lsb && (w1)->msb == (w2)->msb)


typedef unsigned char Byte;

typedef struct {
	Byte lsb;
	Byte msb;
} Word;


Byte         byte_add_with_carry (Byte a, Byte b, xbool_t *carry);
unsigned int byte_rotate_left (Byte b);
unsigned int byte_rotate_right (Byte b);
void         byte_set_bit (Byte b, int bit, xbool_t state);

void         word_set (Word *w, int data);
void         word_copy (Word *w_dest, Word *w_source);
int          word_to_integer (Word *w);


#endif

