/* xerror.h
 *
 * Copyright (C) 2009, 2016, 2020 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#ifndef HAVE_XERROR_H
#define HAVE_XERROR_H


typedef struct _XError XError;

struct _XError {
	char *message;
	int  code;
};

XError* xerror_new (void);
void    xerror_free (XError *err);
int     xerror_set (XError **err, int code, const char *message);
void    xerror_clear (XError *err);


#endif /* HAVE_XERROR_H */

